{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Uses LogFile,
     VGA,
     HHG,
     Keyboard,
     VGA_A,
     Stars11,
     Font6x6,
     CRT,
     Num6x6;

Const
  MAX_SHIELD = 8;
  NUM_WEAPONS = 11;

  CTL_KEYBOARD = 0;

  Done     : ByteBool = False;
  Timer_On : ByteBool = True;

  Max_Projectiles = 255;

  MAX_LIFE = 8;

  NUM_CHAFF   = 49;
  CHAFF_DELAY = 20;

  N_Stars : Word = 100;
  VSync   : ByteBool = False;

  Num_Pixels = 16 * 16;

Type
  TMenuString = String[30];

Const
  VSYNC_STR : String[30] = 'VERTICAL RETRACE ';
  TIMER_STR : String[10] = 'TIMER ';

  MainMenu : Array[0..5] of TMenuString =
  ('KILL YOUR FRIEND NOW','CUSTOM WEAPON COMBAT','VERTICAL RETRACE OFF','TIMER ON','NUMBER OF STARS','EXIT');

Type
  TPixel = Record
    X, Y  : Integer;
    Color : Byte;
    VX,
    VY    : ShortInt;
  end;

  TWeapon = Record
    W_Name  : String[15];
    W_Img   : Byte;
    W_Rate  : Byte;
    W_Speed : ShortInt;
  end;

  TChaff = Record
    X, Y   : Integer;
    XV, YV : Integer;
  end;

Type
  TProjectile = Record
    X, Y   : Word;
    Active : ByteBool;
    N      : Byte;
  end;

  TShip = Record
    ChaffCnt       : Word;
    ChaffReady     : ByteBool;
    ChaffFire      : ByteBool;
    HasChaff       : ByteBool;
    Cash           : LongInt;
    Shield         : Byte;
    Name           : String[10];
    Adv_Tracking   : Byte;
    Adv_Wpn_Firing : ByteBool;
    Adv_Count      : Byte;
    Adv_Anim       : Byte;
    Adv_X,
    Adv_Y          : Word;
    Adv_Enabled    : ByteBool;
    Basic_Name     : String[15];
    Adv_Name       : String[15];
    Adv_Wpn        : ByteBool;
    Life_Pos       : Word;
    Dead           : ByteBool;
    Fire_Delay     : Byte;
    Fire_Count     : Byte;
    Max_X          : Word;
    Min_X          : Word;
    Keys           : TKeys;
    Life           : Byte;
    X, Y           : Word;
    P_Speed        : ShortInt;
    P_Img          : Byte;
    P_Num          : Byte;
    P              : Array[0..Max_Projectiles] of TProjectile;
    Anim           : Byte;
    Count          : Byte;
    Shot_X,
    Shot_Y         : ShortInt;
    Id             : Byte;
    Ctl            : Byte;
    Chaff          : Array[0..NUM_CHAFF] of TChaff;
  end;

Var
  Weapons     : Array[0..NUM_WEAPONS] of TWeapon;
  Wpn_Names   : Array[0..NUM_WEAPONS] of String[35];
  Timer       : Word;
  Timer_32bit : LongInt absolute $0000 : $046C;

  WINNER      : Byte;
  Players     : Array[0..1] of TShip;
  Pixels      : Array[0..Num_Pixels] of TPixel;
  Ships       : TImageFile;
  Proj        : TImageFile;
  X, Y        : Word;

  MX, MY, BN  : Word;
  MX_Old,
  MY_Old      : Word;
  NB          : Integer;
  Mid_X       : Word;
  Mid_Y       : Word;

  ShdImg      : TImageFile;
  Div3        : Array[0..512] of Word;

procedure InitTable;
var I : Word;
  begin
    For I := 0 to 512 do
    Div3[I] := I div 3;
  end;

Const
  SECRET_LASER : TWeapon =
  (W_Name:'SUPER LASER';W_Img:0;W_Rate:0;W_Speed:1);

procedure Draw_Shd(const XPos, YPos : Word);
var
  Work_Offset,Offset,X,Y:Word;
  Color : Byte;
  begin
    Work_Offset := 0;
    Offset := (YPos shl 8) + (YPos shl 6) + XPos;
    For Y:=0 to 23 do
      begin
        For X:=0 to 23 do
        With ShdImg do
        if Images[0]^[Work_Offset+X] = 255 then
          begin
            Color := Double_Buffer^[Offset+X];
            With VGA_Pal^[Color] do
            Color := Div3[Red + Green + Blue] + 64 + Random(10);
            if Color < 65 then Color := 65 else
            if Color > 92 then Color := 92;
            Double_Buffer^[Offset+X] := Color;
          end;
        Inc(Offset,320);
        Inc(Work_Offset,24);
      end;
    end;

Procedure Install_Weapon(var Ship : TShip; N : Byte);
  begin
    With Ship, Weapons[N] do
      begin
        Fire_Delay := W_Rate;
        P_Img      := W_Img;
        P_Speed    := W_Speed;
        Basic_Name := W_Name;
      end;
    end;

procedure Weapon_Menu(var Ship : TShip);
Var
  Pos   : Byte;
  Code  : Byte;
  I     : Byte;
  YPos  : Word;
  S1,S2 : String[3];
  K     : Byte;
  XPos  : Word;
  ShdCtl: ByteBool;
  S_Ind : Byte;

  begin
    Pos := 0;
    Repeat
      Stars_Draw;
      Font6x6_Blit_String(0,0,Ship.Name+' SELECT YOUR WEAPON AND SHIELD LEVEL',0);
      Font6x6_Blit_String(0,192,'PRESS ENTER TO INSTALL IT TO YOUR SHIP OR ESC TO EXIT',0);
      Font6x6_Blit_String(130, 12, 'VELOCITY  FIRE RATE',0);
      YPos := 20;

      Code := GetScanCode;
      Case Code of
        Up   : if Pos > 0 then Dec(Pos);
        Down : if Pos < NUM_WEAPONS then Inc(Pos);
        Left : if Ship.Shield > 0 then Dec(Ship.Shield);
        Right: if Ship.Shield < MAX_SHIELD then Inc(Ship.Shield);
      end;
      if Ship.Id = 1 then
        begin
          While Weapons[Pos].W_Speed > 0 do
          if Pos < NUM_WEAPONS then Inc(Pos) else Pos := 0;
        end
      else
        begin
          While Weapons[Pos].W_Speed < 0 do
          if Pos < NUM_WEAPONS then Inc(Pos) else Pos := 0;
        end;

       Font6x6_Blit_String(25,162,'SHIELD',0);
       VGA_Set_Color(110);
       VGA_Rectangle(10,170,75,179);
       if Ship.Shield > 0 then
       For S_Ind := 0 to Ship.Shield-1 do
         begin
           VGA_PutImage(11+(S_Ind shl 3),171, Proj.Images[13]^, 8, 8);
         end;

       For I := 0 to NUM_WEAPONS do
         begin
           Str(Abs(Weapons[I].W_Speed), S1);
           Str(Weapons[I].W_Rate, S2);

          if ((Ship.Id = 1) and (Weapons[I].W_Speed > 0))
          or
          ((Ship.Id = 0) and (Weapons[I].W_Speed < 0)) then
          VGA_Bar(0,YPos,120,YPos+6,103) else
          VGA_Bar(0,YPos,120,YPos+6,110);

          Font6x6_Blit_String(1, YPos, Wpn_Names[I], Byte(I<>Pos));

          XPos := 130;
          For K := 0 to Abs(Weapons[I].W_Speed)-1 do
            begin
              VGA_Bar(XPos, YPos, XPos+1, YPos+6, 110);
              Inc(XPos, 3);
            end;
          XPos := 190;
          For K := 0 to (50-Weapons[I].W_Rate) do
            begin
              VGA_Bar(XPos, YPos, XPos, YPos+6, 110);
              Inc(XPos, 2);
            end;

          {
          VGA_Blit_Cool_String(210, YPos, S1+'      '+S2,106);
          }
          Inc(YPos, 8);
        end;
        if VSync then
        VGA_Wait_For_VSync;
        asm
          push ds
          les di,Video_Buffer_Ptr
          lds si,Double_Buffer
          mov cx, 32000 {320*200/2}
          cld
          rep movsw
          pop ds
        end;
      VGA_ClearDevice;
      Stars_Move;
    Until Code in [Esc, Enter];
    if Code = Enter then
    Install_Weapon(Ship, Pos);

    if Players[0].Name = 'INQUISITOR' then
    With Players[0], SECRET_LASER do
      begin
        Fire_Delay := W_Rate;
        P_Img      := W_Img;
        P_Speed    := W_Speed;
        Basic_Name := W_Name;
      end;
  end;

Function Prj_Hit_8x8(const Prj : TProjectile; X, Y : Word) : ByteBool;
  begin
    Prj_Hit_8x8 := (X > Prj.X) and (X < Prj.X + 8) and
                    (Y > Prj.Y) and (Y < Prj.Y + 8);
  end;

Function Prj_Hit_Prj(const Prj1, Prj2 : TProjectile) : ByteBool;
  begin
    Prj_Hit_Prj := (Prj1.X > Prj2.X) and (Prj1.X < Prj2.X + 8) and
                   (Prj1.Y > Prj2.Y) and (Prj1.Y < Prj2.Y + 6);
  end;

Function Prj_Hit_Ship(const Ship : TShip; Prj : TProjectile) : ByteBool;
  begin
    With Ship do
    Prj_Hit_Ship := (Prj_Hit_8x8(Prj, X, Y) or
                    Prj_Hit_8x8(Prj, X+8, Y) or
                    Prj_Hit_8x8(Prj, X, Y+8) or
                    Prj_Hit_8x8(Prj, X+8, Y+8)) and not Ship.Dead;
  end;

Function P_AllChaffDone(const P : TShip) : ByteBool;
Var I : Byte;
  begin
    P_AllChaffDone := True;
    For I := 0 to NUM_CHAFF do
    With P.Chaff[I] do
      begin
        if (X > 0) and (X < 320) and (Y > 0) and (Y < 200) then
          begin
            P_AllChaffDone := False;
            Exit;
          end;
      end;
  end;

Procedure P_Init;
Var I, J : Byte;
  begin
    FillChar(Players, SizeOf(Players), 0);

    Players[1].HasChaff := True;

    Players[0].Shield := 8;
    Players[1].Shield := 8;

    Players[0].Name := 'HUNTER';
    Players[1].Name := 'MINER';

    Players[0].Adv_Anim := 10;
    Players[0].Adv_Enabled := True;
    Players[0].Basic_Name := 'LASER';
    Players[0].Adv_Name := 'MISSILE';
    Players[1].Basic_Name := 'SPACE MINE';
    Players[1].Adv_Name := 'NOTHING';

    Players[1].Id := 1;

    Players[0].Life_Pos := 0;
    Players[1].Life_Pos := 320-65;

    Players[0].Shot_X := 16;
    Players[0].Shot_Y := 4;
    Players[1].Shot_X := -8;
    Players[1].Shot_Y := 4;

    Players[0].Fire_Delay := 10;
    Players[1].Fire_Delay := 5;
    Players[0].Keys := P1_Keys;
    Players[1].Keys := P2_Keys;
    Players[1].Count := 9;

    Players[0].Max_X := 120;
    Players[0].Min_X := 4;
    Players[1].Max_X := 320-16-4;
    Players[1].Min_X := 160-16+1;

    {!!!}
    Players[1].Ctl := CTL_KEYBOARD;
    Mid_X          := 160;
    Mid_Y          := 100;

    Players[0].X := 50;
    Players[1].X := 150;
    Players[0].Y := 100-8;
    Players[1].Y := 100-8;
    Players[0].P_Speed := 2;
    Players[0].P_Img := 0;
    Players[1].P_Speed := -1;
    Players[1].P_Img := 1;

    For I := 0 to 1 do
      begin
        Players[I].Life := MAX_LIFE;
        For J := 0 to Max_Projectiles do
          begin
            X := Players[I].X + Players[I].Shot_X;
            Y := Players[I].Y + Players[I].Shot_Y;
          end;
      end;

    Install_Weapon(Players[0], 6);
    Install_Weapon(Players[1], 0);
  end;

Procedure D_Init(X, Y : Word;Img : VGA_Buffer_Ptr);
Var
  I      : Word;
  A, B   : Word;
begin
  A := 0;
  B := 0;
  For I := 0 to Num_Pixels do
    begin
      if A < 16 then Inc(A) else
        begin
          A := 0;
          Inc(B);
        end;
      Pixels[I].X := X + A;
      Pixels[I].Y := Y + B;
      Pixels[I].Color := Img^[I];
      Pixels[I].VX := 1 + Random(5);
      if Random(2) = 1 then Pixels[I].VX := - Pixels[I].VX;
      Pixels[I].VY := 1 + Random(5);
      if Random(2) = 1 then Pixels[I].VY := - Pixels[I].VY;
    end;
end;

procedure D_Big_Bang(X, Y : Word);
Var I : Word;
  begin
    For I := 0 to Num_Pixels do
    With Pixels[I] do
      begin
        if (X >= 0) and (X <= 319) and
           (Y >= 0) and (Y <= 199) then
           VGA_Put_Pixel(X, Y, Color);
           X := X + VX;
           Y := Y + VY;
      end;
  end;

Procedure P_Move;
Var
  I, J, K : Byte;
  Num     : Byte;
  Hit     : ByteBool;
  Enemy   : Byte;
  Pro     : TProjectile;
  LOC_FIRING : ByteBool;
  Index   : Byte;
  begin
    For I := 0 to 1 do
    With Players[I], Players[I].Keys do
      begin
        Enemy := Byte(not ByteBool(I));

        if not Dead then
          begin
            if Ctl = CTL_KEYBOARD then
              begin
                if KeysArr[LeftKey] and (X > Min_X) then Dec(X) else
                if KeysArr[RightKey] and (X < Max_X) then Inc(X);
                if KeysArr[UpKey] and (Y > 4) then Dec(Y) else
                if KeysArr[DownKey] and (Y < 200-16-4) then Inc(Y);
                LOC_FIRING := KeysArr[FireKey];
                Adv_Wpn := KeysArr[RShift] and Adv_Enabled;
                ChaffReady := KeysArr[Alt_X] and HasChaff and not ChaffFire;

                if ChaffReady and LOC_FIRING then
                  begin
                    ChaffFire := True;
                    For Index := 0 to Num_Chaff do
                      begin
                        Chaff[Index].XV := -1;
                        Chaff[Index].YV := 3 - Random(7);
                        Chaff[Index].X  := X - Random(16);
                        Chaff[Index].Y  := Y + Random(16);
                        ChaffCnt := CHAFF_DELAY;
                      end;
                  end;
              end;

            if LOC_FIRING and (P_Num < Max_Projectiles) then
              begin
                if Adv_Wpn and (not Adv_Wpn_Firing) and (Adv_Enabled) then
                  begin
                    Adv_Wpn_Firing := True;
                    Adv_X := X + Shot_X;
                    Adv_Y := Y + Shot_Y;
                  end
                else
                if (not Adv_Wpn) and (not ChaffFire) then
                  begin
                    if Fire_Count < Fire_Delay then
                    Inc(Fire_Count) else
                      begin
                        Fire_Count := 0;
                        Num := 0;
                        While P[Num].Active do Inc(Num);
                        P[Num].Active := True;
                       P[Num].N := Num;
                        Inc(P_Num);
                      end;
                    end;
                  end;

       if (Players[1].ChaffFire) then
       For Index := 0 to NUM_CHAFF do
         With Chaff[Index] do
           begin
             if (X >= Players[0].Adv_X) and (Y >= Players[0].Adv_Y) and
                (X <= Players[0].Adv_X + 6) and (Y <= Players[0].Adv_Y + 4) then
                  begin
                    Players[0].Adv_Wpn_Firing := False;
                  end;
           end;


        if ChaffFire then
          begin
            For Index := 0 to Num_Chaff do
            With Chaff[Index] do
              begin
                X := X + XV;
                Y := Y + YV;
                if ChaffCnt > 0 then Dec(ChaffCnt) else
                  begin
                    ChaffCnt := CHAFF_DELAY;
                    if YV > 0 then Dec(YV) else
                    if YV < 0 then Inc(YV);
                  end;
              end;
            if P_AllChaffDone(Players[I]) then
            ChaffFire := False;
          end
        else
        if Adv_Enabled and Adv_Wpn_Firing then
          begin
            if Adv_X + 8 < 319 then Inc(Adv_X) else
            Adv_Wpn_Firing := False;
            if Adv_Tracking < 1 then Inc(Adv_Tracking) else
              begin
                Adv_Tracking := 0;
                if Adv_Y < Players[Enemy].Y+4 then Inc(Adv_Y) else
                if Adv_Y > Players[Enemy].Y+4 then Dec(Adv_Y);
              end;

            Pro.X := Adv_X;
            Pro.Y := Adv_Y;

            if Prj_Hit_Ship(Players[Enemy], Pro) then
              begin
                Adv_Wpn_Firing := False;
                D_Init(Players[Enemy].X, Players[Enemy].Y, VGA_Buffer_Ptr(Ships.Images[0]));
                Players[Enemy].Life := 0;
                Players[Enemy].Dead := True;
                Winner := I;
              end;
          end;

        For J := 0 to Max_Projectiles do
        With P[J] do
        if Active then
          begin
            For K := 0 to Max_Projectiles do
              begin
                if Players[Enemy].P[K].Active and P[J].Active and
                   Prj_Hit_Prj(P[J], Players[Enemy].P[K]) then
                     begin
                       P[J].Active := False;
                       Players[Enemy].P[K].Active := False;
                     end;
              end;

            Hit := Prj_Hit_Ship(Players[Enemy], P[J]);
            if ((X + 8 < 320 - P_Speed) and
               (X > Abs(P_Speed))) and (not Hit) then X := X + P_Speed else
              begin
                if Hit then
                  begin
                    if Players[Enemy].Shield > 0 then Dec(Players[Enemy].Shield) else
                    if Players[Enemy].Life > 1 then Dec(Players[Enemy].Life) else
                      begin
                        D_Init(Players[Enemy].X, Players[Enemy].Y, VGA_Buffer_Ptr(Ships.Images[0]));
                        Players[Enemy].Life := 0;
                        Players[Enemy].Dead := True;
                        Winner := I;
                      end;
                  end;
                Active := False;
                X := Players[I].X + Players[I].Shot_X;
                Y := Players[I].Y + Players[I].Shot_Y;;
                if P_Num > 0 then Dec(P_Num);
              end;
          end
        else
          begin
            X := Players[I].X + Players[I].Shot_X;
            Y := Players[I].Y + Players[I].Shot_Y;;
          end;
      end;
   end;
 end;

Procedure P_Draw;
Var
  I, J : Byte;
  XPos : Word;
  Frame: Byte;
  Enemy: Byte;
  Index: Byte;
  begin
    For I := 0 to 1 do
    With Players[I] do
      begin
        Enemy := Byte(not ByteBool(I));
        if not Dead then
        For J := 0 to Max_Projectiles do
          begin
            if P[J].Active then
            With P[J] do
            VGA_PutImage_Trans(X, Y, Proj.Images[P_Img]^, 8, 8);
          end;

        if Adv_Enabled and Adv_Wpn_Firing and not Dead then
          begin
            VGA_PutImage_Trans(Adv_X, Adv_Y, Proj.Images[Adv_Anim]^, 8, 8);
            if Adv_Count < 5 then Inc(Adv_Count) else
              begin
                Adv_Count := 0;
                if Adv_Anim < 12 then Inc(Adv_Anim) else
                Adv_Anim := 10;
              end;
          end
        else
        if HasChaff and ChaffFire and not Dead then
        For Index := 0 to NUM_CHAFF do
        With Chaff[Index] do
          begin
            if (X > 0) and (X < 320) and (Y > 0) and (Y < 200) then
            VGA_Put_Pixel(X, Y, 40 + Random(10));
          end;

        if not Dead then
          begin
            VGA_PutImage_Trans(X, Y, Ships.Images[Anim]^, 16, 16);

            if Shield > 0 then
            Draw_Shd(X-4, Y-4);
            if Players[Enemy].Adv_Wpn then
            VGA_PutImage_Trans(X, Y, Ships.Images[4]^, 16, 16);
            Font6x6_Blit_String(Life_Pos, 192, Name, 0);
          end
        else
          begin
            Font6x6_Blit_String(100, 92, Players[Enemy].Name + ' WINS', 0);
            D_Big_Bang(X, Y);
          end;

        XPos  := Life_Pos;
        if Adv_Wpn then
        Font6x6_Blit_String(XPos, 9, Adv_Name, 0) else
        if ChaffReady then
        Font6x6_Blit_String(XPos, 9, 'CNTRMEASURE', 0) else
        Font6x6_Blit_String(XPos, 9, Basic_Name, 0);

        Frame := 9;
        if (Life > 0) then
        For J := 0 to Life-1 do
          begin
            VGA_PutImage_Trans(XPos, 0, Proj.Images[Frame]^, 8, 8);
            Inc(XPos,8);
            Dec(Frame);
          end;
        XPos  := Life_Pos;
        if (Shield > 0) then
        For J := 0 to Shield-1 do
          begin
            VGA_PutImage_Trans(XPos, 16, Proj.Images[13]^, 8, 8);
            Inc(XPos,8);
          end;

        if Count < 20 then Inc(Count) else
          begin
            if Anim < 3 then Inc(Anim) else Anim := 0;
            Count := 0;
          end;
      end;
  end;

Function Menu(X, Y : Word; S : Array of TMenuString; P0 : Byte) : Integer;
Var
  I   : Byte;
  Pos : Byte;
  YPos: Word;
  Code: Byte;
  Logo: TImageFile;
  begin
    HHG_Load('MEGALOGO.HHG', Logo);
    Pos := P0;
    Repeat
      Stars_Draw;
      VGA_PutImage_Trans(100, 20, Logo.Images[0]^, 100, 50);
      VGA_Blit_Cool_String(0,192,'(C)2000 The Great Inquisitor & The Cat', 107);
      VGA_Blit_Cool_String(0, 0, 'Ver. 1.2', 103);
      Code := GetScanCode;
      Case Code of
        Up   : if Pos > 0 then Dec(Pos) else Pos := High(S);
        Down : if Pos < High(S) then Inc(Pos) else Pos := 0;
      end;
      YPos := Y;
      For I := 0 to High(S) do
        begin
          Font6x6_Blit_String(X, YPos, S[I], Byte(Pos <> I));
          Inc(YPos, 8);
        end;
        if VSync then
        VGA_Wait_For_VSync;
        asm
          push ds
          les di,Video_Buffer_Ptr
          lds si,Double_Buffer
          mov cx, 32000 {320*200/2}
          cld
          rep movsw
          pop ds
        end;
        VGA_ClearDevice;
        Stars_Move;
    Until Code = Enter;
    HHG_FreeMem(Logo);
    Menu := Pos;
  end;

Procedure Run_Combat;
var
  Timer_Delay  : Word;
  Old_Timer    : LongInt;
  I            : Byte;
  Enemy        : Byte;
  Who_Will_Die : Byte;
  Timeout_Done : ByteBool;

begin
  Winner := 255;
  Timer := 90;
  Init_Key;
  Old_Timer := Timer_32bit;
  TimeOut_Done := False;
  Repeat
    Stars_Draw;
    P_Draw;
    if Timer_On then
      begin
        if Timer > 0 then Num6x6_Draw(152,0,Timer,Byte(Timer <= 10)) else
        Font6x6_Blit_String(139,0,'TIMEOUT',0);
      end;
    if VSync then
    VGA_Wait_For_VSync;
    asm
      push ds
      les di,Video_Buffer_Ptr
      lds si,Double_Buffer
      mov cx, 32000 {320*200/2}
      cld
      rep movsw
      pop ds
    end;
    VGA_ClearDevice;
    P_Move;
    Stars_Move;
    Done := KeysArr[Esc];

    if (Timer_32bit - 18 = Old_Timer) and (Winner = 255) and (Timer_On) then
      begin
        Old_Timer := Timer_32bit;
        if Timer > 0 then Dec(Timer) else
        if not Timeout_Done then
          begin
            Timeout_Done := True;
            For I := 0 to 1 do
             begin
               Enemy := Byte(not ByteBool(I));
               if Players[I].Life > Players[Enemy].Life then
               Who_Will_Die := Enemy else
               if Players[I].Life < Players[Enemy].Life then
               Who_Will_Die := I else
               Who_Will_Die := 255;
               if Who_Will_Die <> 255 then
                 begin
                   D_Init(Players[Who_Will_Die].X,
                                  Players[Who_Will_Die].Y,
                                  VGA_Buffer_Ptr(Ships.Images[0]));
                   Players[Who_Will_Die].Life := 0;
                   Players[Who_Will_Die].Dead := True;
                 end;
             end;
          end;
      end;
  Until Done;
  Done_Key;
end;

Function Graph_ReadLn(S0 : String; X,Y:Word) : String;
var
  S    : String;
  Code : Byte;
  Ch   : Char;
  Time : Word;

  begin
    Ch := #0;
    Time := 0;
    S := S0;
    VGA_Bar(X,Y,X+200,Y+11,103);
    VGA_Set_Color(100);
    VGA_Rectangle(X-1,Y-1,X+201,Y+12);
    VGA_Set_Color(108);
    Repeat
      VGA_Blit_String(X + 2, Y + 2, S);
      if Time < 25 then
      VGA_HLine(X+Length(S)*8+2,X+Length(S)*8+9, Y+9);
      asm
        push ds
        les di,Video_Buffer_Ptr
        lds si,Double_Buffer
        mov cx, 32000 {320*200/2}
        cld
        rep movsw
        pop ds
      end;
      VGA_Bar(X,Y,X+200,Y+11,103);
      if KeyPressed then
        begin
          Ch := ReadKey;
          Ch := UpCase(Ch);
          if (Ch in ['A'..'Z',' ']) and (Length(S) < 10) then S := S + Ch else
          Case Ch of
            #8 : Delete(S, Length(S), 1);
          end;
        end;
      if Time < 50 then Inc(Time) else Time := 0;
    Until Ch in [#13, #27];
    if Ch = #13 then Graph_ReadLn := S
    else Graph_ReadLn := '';
  end;

Function Graph_GetNum(Old:Word; X,Y:Word) : Word;
var
  S    : String;
  Code : Byte;
  Ch   : Char;
  Time : Word;
  W    : Word;
  Res  : Integer;
  begin
    W := 0;
    Ch := #0;
    Time := 0;
    Str(Old, S);
    VGA_Bar(X,Y,X+200,Y+11,103);
    VGA_Set_Color(100);
    VGA_Rectangle(X-1,Y-1,X+201,Y+12);
    VGA_Set_Color(108);
    Repeat
      VGA_Blit_String(X + 2, Y + 2, S);
      if Time < 25 then
      VGA_HLine(X+Length(S)*8+2,X+Length(S)*8+9, Y+9);
      asm
        push ds
        les di,Video_Buffer_Ptr
        lds si,Double_Buffer
        mov cx, 32000 {320*200/2}
        cld
        rep movsw
        pop ds
      end;
      VGA_Bar(X,Y,X+200,Y+11,103);
      if KeyPressed then
        begin
          Ch := ReadKey;
          Ch := UpCase(Ch);
          if (Ch in ['0'..'9']) and (Length(S) < 5) then S := S + Ch else
          Case Ch of
            #8 : Delete(S, Length(S), 1);
          end;
        end;
      if Time < 50 then Inc(Time) else Time := 0;
    Until Ch  in [#13, #27];
    Val(S, W, Res);
    if Ch = #13 then Graph_GetNum := W else
    Graph_GetNum := Old;
  end;

Procedure Set_Num_Stars;
Var
  Code : Byte;
  TempS      : String[5];
  begin
    Repeat
      Code := GetScanCode;
      Font6x6_Blit_String(0,0,'NUMBER OF STARS',0);
      Font6x6_Blit_String(0,180,'PRESS SPACE TO MODIFY',0);
      Font6x6_Blit_String(0,192,'PRESS ENTER TO ACCEPT',0);
      Str(N_Stars, TempS);
      VGA_Blit_Cool_String(140, 92, TempS, 10);
      Case Code of
        Up   : if N_Stars < 10000 then Inc(N_Stars) else N_Stars := 1;
        Down : if N_Stars > 1 then Dec(N_Stars) else N_Stars := 10000;
        Space: begin
                 N_Stars := Graph_GetNum(N_Stars,60,90);
               end;
      end;
      asm
        push ds
        les di,Video_Buffer_Ptr
        lds si,Double_Buffer
        mov cx, 32000 {320*200/2}
        cld
        rep movsw
        pop ds
      end;
      VGA_ClearDevice;
    Until Code = Enter;
    if N_Stars = 0 then N_Stars := 1;
    Stars_Done;
    Stars_Init(N_Stars);
  end;

Procedure Enter_Names;
Var
  I : Byte;
  S : String;
  C : Char;
  begin
    C := '1';
    For I := 0 to 1 do
    With Players[I] do
      begin
        VGA_ClearDevice;
        VGA_Blit_Cool_String(55,60,'Enter Player '+C+' Name',105);
        S := Graph_ReadLn(Players[I].Name, 55,70);
        if S <> '' then
        Players[I].Name := S;
        Inc(C);
      end;
  end;

procedure Init_Weapons;
Var
  T : Text;
  I : Byte;
begin
  Assign(T, 'WEAPONS.INI');
  {$I-}
  ReSet(T);
  if IOResult <> 0 then VGA_Fatal_Error('Can not open WEAPONS.INI');
  For I := 0 to NUM_WEAPONS do
  With Weapons[I] do
    begin
      ReadLn(T, W_Name);
      ReadLn(T, W_Img);
      ReadLn(T, W_Rate);
      ReadLn(T, W_Speed);
      if IOResult <> 0 then VGA_Fatal_Error('Error reading weapon data');
    end;
  For I := 0 to NUM_WEAPONS do
    begin
      ReadLn(T, Wpn_Names[I]);
      if IOResult <> 0 then VGA_Fatal_Error('Error reading weapon names');
    end;
  Close(T);
end;

Var
  MenuResult : Byte;
  Index      : Byte;

begin
  InitTable;
  MenuResult := 0;
  LOG_Init_2('SHIPS.LOG');
  HHG_Load('SHIPS.HHG', Ships);
  HHG_Load('PROJ.HHG', Proj);
  HHG_Load('SHD.HHG', ShdImg);
  VGA_Init;
  Stars_Init(N_Stars);
  Init_Weapons;
  Font6x6_Init('font6x6.hhg');
  Num6x6_Init;
  Repeat
    P_Init;
    MenuResult := Menu(92,70,MainMenu, MenuResult);
    Case MenuResult of
      0 : begin
            Enter_Names;
            Run_Combat;
          end;
      1 : begin
            Enter_Names;
            For Index := 0 to 1 do
            Weapon_Menu(Players[Index]);
            Run_Combat;
          end;
      2 : begin
            VSync := not VSync;
            if VSync then
            MainMenu[2] := VSYNC_STR + 'ON' else
            MainMenu[2] := VSYNC_STR + 'OFF';
          end;
      3 : begin
            Timer_On := not Timer_On;
            if Timer_On then
            MainMenu[3] := TIMER_STR + 'ON' else
            MainMenu[3] := TIMER_STR + 'OFF';
          end;
      4 : Set_Num_Stars;
    end;
  Until MenuResult = 5;
  Stars_Done;
  Num6x6_Done;
  Font6x6_Done;
  VGA_Done;
  HHG_FreeMem(ShdImg);
  HHG_FreeMem(Ships);
  HHG_FreeMem(Proj);
  LOG_Close;
end.