Unit Keyboard;

Interface

uses DOS;

const
  {-   ᯮ㥬 }
  Esc=1;
  _1 = 2;
  _2 = 3;
  _3 = 4;
  _4 = 5;
  _5 = 6;
  _6 = 7;
  _7 = 8;
  _8 = 9;
  _9 = 10;
  _0 = 11;
  Minus=12;
  Equal=13;
  BackSpace=14;
  Enter=28;
  Space=57;
  Up=72;
  Down=80;
  Left=75;
  Right=77;
  Ins=82;
  Del=83;
  F1=59;
  F2=60;
  F3=61;
  F4=62;
  F5=63;
  F6=64;
  F7=65;
  F8=66;
  F9=67;
  F10=68;
  Tab=15;
  Page_Up = 73;
  Page_Down = 81;

  _Home = 71;
  _End = 79;

  LShift=42;
  RShift=54;
  Ctrl=29;
  Alt=56;
  _C = 46;
  _R = 19;
  _A = 30;
  _Z = 44;
  _Y = 21;
  _W = 17;
  _S = 31;
  _D = 32;

  Alt_F3=106;
  Alt_Q = 16;
  Alt_W = 17;
  Alt_E = 18;
  Alt_R = 19;
  Alt_T = 20;
  Alt_Y = 21;
  Alt_U = 22;
  Alt_I = 23;
  Alt_O = 24;
  Alt_P = 25;
  Alt_A = 30;
  Alt_S = 31;
  Alt_D = 32;
  Alt_F = 33;
  Alt_G = 34;
  Alt_H = 35;
  Alt_J = 36;
  Alt_K = 37;
  Alt_L = 38;
  Alt_Z = 44;
  Alt_X = 45;
  Alt_C = 46;
  Alt_V = 47;
  Alt_B = 48;
  Alt_N = 49;
  Alt_M = 50;

  Gray_Plus  = 78;
  Gray_Minus = 74;

  Keyboard_Int=$9;
  Key_Buffer=$60;
  Key_Control=$61;
  Int_Control=$20;

var
  Raw_Key : Word;
  KeysArr : Array[0..128]of ByteBool;
  Code    : Word;

type
  TKeys=Record
    UpKey,
    DownKey,
    LeftKey,
    RightKey,
    FireKey,
    AB,
    W1,
    W2,
    W3,
    W4,
    W5    : Byte;
  end;

Const
  P1_Keys:TKeys=(UpKey:Up;DownKey:Down;LeftKey:Left;
                 RightKey:Right;FireKey:Ctrl;AB:RShift;W1:_1;W2:_2;W3:_3;W4:_4;W5:_5);

  P2_Keys:TKeys=(UpKey:_W;DownKey:_S;LeftKey:_A;
                 RightKey:_D;FireKey:Alt;AB:LShift;W1:_6;W2:_7;W3:_8;W4:_9;W5:_0);


function GetScanCode:Byte;
procedure Init_Key;
procedure Done_Key;
procedure Wait;
function KeyPressed : Boolean;

Implementation

var
  Old_Int_9h : Pointer;
  Key_Byte   : Byte absolute 0000:1047;
  B          : Byte;

function GetScanCode:Byte;
  begin
    asm
      mov ah,01h {஢ઠ  }
      int 16h    {}
      jz @empty  {if not KeyPressed then Exit}
      mov ah,00h { ᪠-}
      int 16h    {}
      mov al,ah  {al -  ah}
      xor ah,ah  {塞 ah}
      jmp @done

      @empty:
      xor ax,ax

      @done:
      mov @Result,al
    end;
  end;

procedure NewInt9h(Port : Byte);
begin
  if Port > 128 then KeysArr[Port-128] := False
  else KeysArr[Port] := True;
end;

{$F+}
procedure KBHandler; Interrupt;
var
  Port : Byte;
begin
  asm
    cli
    in al, 60h
    mov port, al
    in al, 61h
    mov ah, al
    or al, 80h
    out 61h, al
    mov al, ah
    out 61h, al
    sti
  end;
    NewInt9h(Port);
  asm
    mov al, 20h
    out 20h, al
  end;
end;
{$F-}

var
  Index : Byte;

Const
  KB_Set : ByteBool = False;

procedure Init_Key;
begin
  B := Key_Byte;

  For Index := 0 to 128 do
  KeysArr[Index] := False;

  GetIntVec($09, Old_Int_9h);
  SetIntVec($09, @KBHandler);

  KB_Set := True;
end;

procedure Done_Key;
begin
  if not KB_Set then Exit;
  SetIntVec($09, Old_Int_9h);
  Key_Byte := B;
End;

procedure Wait;
  begin
    while GetScanCode=0 do;
  end;

function KeyPressed : Boolean;
  begin
    KeyPressed := GetScanCode <> 0;
  end;

end.

